
proc do_trace {n label seglist} {

  set height 100

  set ybase [expr $n * $height]
  set low $ybase
  set high [expr $ybase - $height + 10]

  set x 0
  set y 0
  set xc 0
  set yc $low

  :draw modify :tag t$n :delete T

  set i 0
  foreach s $seglist {
    incr x $s
    if {$y == $low} then {set y $high} else {set y $low}

    if {$i == 0} then {
      :draw line :tag t$n :colour red  :value $xc $yc $x $y
    } else {
      :draw line :tag t$n :colour red  :value $xc $yc $xc $y $x $y
    }

    set xc $x
    set yc $y
    incr i
  }

  :draw text :tag l$n :delete T :colour black :text "Trace $n:   $label" :value 20 [expr $high + 10]

}


   set frame [self frame-name].demo
   set title "Canvas Sample"

   :frame $frame :label $title :show-footer F :resize F

   wm protocol $frame WM_DELETE_WINDOW {destroy [self frame-name].demo}

  :canvas TRACE  :w 1000 :h 800

  :show T

  for {set i 1} {$i <= 8} {incr i} {
  do_trace $i "" {1000}
  }

  set seglist {50 20 80 50  50 20 80 50  50 20 80 50  50 20 80 50  50 20 80 50}

  do_trace 1 "the top one" $seglist

  set seglist {50 80 20 50  50 80 20 50  50 80 20 50  50 80 20 50  50 80 20 50}

  do_trace 2 "the next one " $seglist

  do_trace 8 "the bottom one" {250 5 5 5 5 5 5 5 5 5 5 700}


